Index: /XIOS/trunk/src/context_client.cpp
===================================================================
--- /XIOS/trunk/src/context_client.cpp	(revision 1536)
+++ /XIOS/trunk/src/context_client.cpp	(revision 1537)
@@ -11,4 +11,5 @@
 #include "timer.hpp"
 #include "cxios.hpp"
+#include "server.hpp"
 
 namespace xios
@@ -18,5 +19,5 @@
     \param [in] intraComm_ communicator of group client
     \param [in] interComm_ communicator of group server
-    \cxtSer [in] cxtSer Pointer to context of server side. (It is only used on case of attached mode)
+    \cxtSer [in] cxtSer Pointer to context of server side. (It is only used in case of attached mode).
     */
     CContextClient::CContextClient(CContext* parent, MPI_Comm intraComm_, MPI_Comm interComm_, CContext* cxtSer)
@@ -34,4 +35,15 @@
       else  MPI_Comm_size(interComm, &serverSize);
 
+      computeLeader(clientRank, clientSize, serverSize, ranksServerLeader, ranksServerNotLeader);
+
+      timeLine = 0;
+    }
+
+    void CContextClient::computeLeader(int clientRank, int clientSize, int serverSize,
+                                       std::list<int>& rankRecvLeader,
+                                       std::list<int>& rankRecvNotLeader)
+    {
+      if ((0 == clientSize) || (0 == serverSize)) return;
+
       if (clientSize < serverSize)
       {
@@ -49,7 +61,7 @@
 
         for (int i = 0; i < serverByClient; i++)
-          ranksServerLeader.push_back(rankStart + i);
-
-        ranksServerNotLeader.resize(0);
+          rankRecvLeader.push_back(rankStart + i);
+
+        rankRecvNotLeader.resize(0);
       }
       else
@@ -61,7 +73,7 @@
         {
           if (clientRank % (clientByServer + 1) == 0)
-            ranksServerLeader.push_back(clientRank / (clientByServer + 1));
+            rankRecvLeader.push_back(clientRank / (clientByServer + 1));
           else
-            ranksServerNotLeader.push_back(clientRank / (clientByServer + 1));
+            rankRecvNotLeader.push_back(clientRank / (clientByServer + 1));
         }
         else
@@ -69,11 +81,9 @@
           int rank = clientRank - (clientByServer + 1) * remain;
           if (rank % clientByServer == 0)
-            ranksServerLeader.push_back(remain + rank / clientByServer);
+            rankRecvLeader.push_back(remain + rank / clientByServer);
           else
-            ranksServerNotLeader.push_back(remain + rank / clientByServer);
-        }        
-      }
-
-      timeLine = 0;
+            rankRecvNotLeader.push_back(remain + rank / clientByServer);
+        }
+      }
     }
 
@@ -86,11 +96,28 @@
       list<int> ranks = event.getRanks();
 
+      if (CXios::checkEventSync)
+      {
+        int typeId, classId, typeId_in, classId_in, timeLine_out;
+        typeId_in=event.getTypeId() ;
+        classId_in=event.getClassId() ;
+//        MPI_Allreduce(&timeLine,&timeLine_out, 1, MPI_UINT64_T, MPI_SUM, intraComm) ; // MPI_UINT64_T standardized by MPI 3
+        MPI_Allreduce(&timeLine,&timeLine_out, 1, MPI_LONG_LONG_INT, MPI_SUM, intraComm) ; 
+        MPI_Allreduce(&typeId_in,&typeId, 1, MPI_INT, MPI_SUM, intraComm) ;
+        MPI_Allreduce(&classId_in,&classId, 1, MPI_INT, MPI_SUM, intraComm) ;
+        if (typeId/clientSize!=event.getTypeId() || classId/clientSize!=event.getClassId() || timeLine_out/clientSize!=timeLine)
+        {
+           ERROR("void CContextClient::sendEvent(CEventClient& event)",
+               << "Event are not coherent between client.");
+        }
+      }
+
       if (!event.isEmpty())
       {
         list<int> sizes = event.getSizes();
 
-        // We force the getBuffers call to be non-blocking on the servers
+        // We force the getBuffers call to be non-blocking on classical servers
         list<CBufferOut*> buffList;
-        bool couldBuffer = getBuffers(ranks, sizes, buffList, !CXios::isClient);
+        bool couldBuffer = getBuffers(ranks, sizes, buffList, (!CXios::isClient && (CServer::serverLevel == 0) ));
+//        bool couldBuffer = getBuffers(ranks, sizes, buffList, CXios::isServer );
 
         if (couldBuffer)
@@ -113,5 +140,5 @@
           for (list<int>::const_iterator it = sizes.begin(); it != sizes.end(); it++)
             tmpBufferedEvent.buffers.push_back(new CBufferOut(*it));
-
+          info(100)<<"DEBUG : temporaly event created : timeline "<<timeLine<<endl ;
           event.send(timeLine, tmpBufferedEvent.sizes, tmpBufferedEvent.buffers);
         }
@@ -140,4 +167,5 @@
             (*itBuffer)->put((char*)(*it)->start(), (*it)->count());
 
+          info(100)<<"DEBUG : temporaly event sent "<<endl ;
           checkBuffers(tmpBufferedEvent.ranks);
 
@@ -181,5 +209,6 @@
      * \return whether the already allocated buffers could be used
     */
-    bool CContextClient::getBuffers(const list<int>& serverList, const list<int>& sizeList, list<CBufferOut*>& retBuffers, bool nonBlocking /*= false*/)
+    bool CContextClient::getBuffers(const list<int>& serverList, const list<int>& sizeList, list<CBufferOut*>& retBuffers,
+                                    bool nonBlocking /*= false*/)
     {
       list<int>::const_iterator itServer, itSize;
@@ -210,7 +239,21 @@
         {
           checkBuffers();
-          context->server->listen();
+          if (CServer::serverLevel == 0)
+            context->server->listen();
+
+          else if (CServer::serverLevel == 1)
+          {
+            context->server->listen();
+            for (int i = 0; i < context->serverPrimServer.size(); ++i)
+              context->serverPrimServer[i]->listen();
+            CServer::contextEventLoop(false) ; // avoid dead-lock at finalize...
+          }
+
+          else if (CServer::serverLevel == 2)
+            context->server->listen();
+
         }
       } while (!areBuffersFree && !nonBlocking);
+
       CTimer::get("Blocking time").suspend();
 
@@ -251,13 +294,18 @@
       map<int,CClientBuffer*>::iterator itBuff;
       bool pending = false;
-      for (itBuff = buffers.begin(); itBuff != buffers.end(); itBuff++) pending |= itBuff->second->checkBuffer();
+      for (itBuff = buffers.begin(); itBuff != buffers.end(); itBuff++)
+        pending |= itBuff->second->checkBuffer();
       return pending;
    }
 
    //! Release all buffers
-   void CContextClient::releaseBuffers(void)
+   void CContextClient::releaseBuffers()
    {
       map<int,CClientBuffer*>::iterator itBuff;
-      for (itBuff = buffers.begin(); itBuff != buffers.end(); itBuff++) delete itBuff->second;
+      for (itBuff = buffers.begin(); itBuff != buffers.end(); itBuff++)
+      {
+          delete itBuff->second;
+      }
+      buffers.clear();
    }
 
@@ -355,54 +403,72 @@
 
    /*!
-   Finalize context client and do some reports
-   */
-   void CContextClient::finalize(void)
-   {
-     map<int,CClientBuffer*>::iterator itBuff;
-     bool stop = false;
-
-     CTimer::get("Blocking time").resume();
-     while (hasTemporarilyBufferedEvent())
-     {
-       checkBuffers();
-       sendTemporarilyBufferedEvent();
-     }
-     CTimer::get("Blocking time").suspend();
-
-     CEventClient event(CContext::GetType(), CContext::EVENT_ID_CONTEXT_FINALIZE);
-     if (isServerLeader())
-     {
-       CMessage msg;
-       const std::list<int>& ranks = getRanksServerLeader();
-       for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-         event.push(*itRank, 1, msg);
-       sendEvent(event);
-     }
-     else sendEvent(event);
-
-     CTimer::get("Blocking time").resume();
-     while (!stop)
-     {
-       checkBuffers();
-       if (hasTemporarilyBufferedEvent())
-         sendTemporarilyBufferedEvent();
-
-       stop = true;
-       for (itBuff = buffers.begin(); itBuff != buffers.end(); itBuff++) stop &= !itBuff->second->hasPendingRequest();
-     }
-     CTimer::get("Blocking time").suspend();
-
-     std::map<int,StdSize>::const_iterator itbMap = mapBufferSize_.begin(),
-                                           iteMap = mapBufferSize_.end(), itMap;
-     StdSize totalBuf = 0;
-     for (itMap = itbMap; itMap != iteMap; ++itMap)
-     {
-       report(10) << " Memory report : Context <" << context->getId() << "> : client side : memory used for buffer of each connection to server" << endl
-                  << "  +) To server with rank " << itMap->first << " : " << itMap->second << " bytes " << endl;
-       totalBuf += itMap->second;
-     }
-     report(0) << " Memory report : Context <" << context->getId() << "> : client side : total memory used for buffer " << totalBuf << " bytes" << endl;
-
-     releaseBuffers();
-   }
+   * Finalize context client and do some reports. Function is non-blocking.
+   */
+  void CContextClient::finalize(void)
+  {
+    map<int,CClientBuffer*>::iterator itBuff;
+    bool stop = false;
+
+    CTimer::get("Blocking time").resume();
+    while (hasTemporarilyBufferedEvent())
+    {
+      checkBuffers();
+      sendTemporarilyBufferedEvent();
+    }
+    CTimer::get("Blocking time").suspend();
+
+    CEventClient event(CContext::GetType(), CContext::EVENT_ID_CONTEXT_FINALIZE);
+    if (isServerLeader())
+    {
+      CMessage msg;
+      const std::list<int>& ranks = getRanksServerLeader();
+      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+      {
+        info(100)<<"DEBUG : Sent context Finalize event to rank "<<*itRank<<endl ;
+        event.push(*itRank, 1, msg);
+      }
+      sendEvent(event);
+    }
+    else sendEvent(event);
+
+    CTimer::get("Blocking time").resume();
+//    while (!stop)
+    {
+      checkBuffers();
+      if (hasTemporarilyBufferedEvent())
+        sendTemporarilyBufferedEvent();
+
+      stop = true;
+//      for (itBuff = buffers.begin(); itBuff != buffers.end(); itBuff++) stop &= !itBuff->second->hasPendingRequest();
+    }
+    CTimer::get("Blocking time").suspend();
+
+    std::map<int,StdSize>::const_iterator itbMap = mapBufferSize_.begin(),
+                                          iteMap = mapBufferSize_.end(), itMap;
+
+    StdSize totalBuf = 0;
+    for (itMap = itbMap; itMap != iteMap; ++itMap)
+    {
+      report(10) << " Memory report : Context <" << context->getId() << "> : client side : memory used for buffer of each connection to server" << endl
+                 << "  +) To server with rank " << itMap->first << " : " << itMap->second << " bytes " << endl;
+      totalBuf += itMap->second;
+    }
+    report(0) << " Memory report : Context <" << context->getId() << "> : client side : total memory used for buffer " << totalBuf << " bytes" << endl;
+
+    //releaseBuffers(); // moved to CContext::finalize()
+  }
+
+
+  /*!
+  */
+  bool CContextClient::havePendingRequests(void)
+  {
+    bool pending = false;
+    map<int,CClientBuffer*>::iterator itBuff;
+    for (itBuff = buffers.begin(); itBuff != buffers.end(); itBuff++)
+      pending |= itBuff->second->hasPendingRequest();
+    return pending;
+  }
+
+
 }
Index: /XIOS/trunk/src/context_client.hpp
===================================================================
--- /XIOS/trunk/src/context_client.hpp	(revision 1536)
+++ /XIOS/trunk/src/context_client.hpp	(revision 1537)
@@ -40,4 +40,5 @@
       bool checkBuffers(void);
       void releaseBuffers(void);
+      bool havePendingRequests(void);
 
       bool isServerLeader(void) const;
@@ -47,9 +48,12 @@
 
       bool isAttachedModeEnabled() const;
-
       bool hasTemporarilyBufferedEvent() const { return !tmpBufferedEvent.isEmpty(); };
 
+      static void computeLeader(int clientRank, int clientSize, int serverSize,
+                                std::list<int>& rankRecvLeader,
+                                std::list<int>& rankRecvNotLeader);
+
       // Close and finalize context client
-      void closeContext(void);
+//      void closeContext(void);  Never been implemented.
       void finalize(void);
 
@@ -106,10 +110,4 @@
       std::list<int> ranksServerNotLeader;
 
-    public: // Some function should be removed in the future
-      //    void registerEvent(CEventClient& event);
-//    list<CBufferOut*> newEvent(CEventClient& event,list<int>& sizes);
-//    bool locked;
-//    set<int> connectedServer;
-
   };
 }
Index: /XIOS/trunk/src/context_server.cpp
===================================================================
--- /XIOS/trunk/src/context_server.cpp	(revision 1536)
+++ /XIOS/trunk/src/context_server.cpp	(revision 1537)
@@ -29,4 +29,5 @@
     MPI_Comm_size(intraComm,&intraCommSize);
     MPI_Comm_rank(intraComm,&intraCommRank);
+
     interComm=interComm_;
     int flag;
@@ -34,12 +35,15 @@
     if (flag) MPI_Comm_remote_size(interComm,&commSize);
     else  MPI_Comm_size(interComm,&commSize);
+
     currentTimeLine=0;
     scheduled=false;
     finished=false;
-
     boost::hash<string> hashString;
-    hashId=hashString(context->getId());
-
-  }
+    if (CServer::serverLevel == 1)
+      hashId=hashString(context->getId() + boost::lexical_cast<string>(context->clientPrimServer.size()));
+    else
+      hashId=hashString(context->getId());
+  }
+
   void CContextServer::setPendingEvent(void)
   {
@@ -128,9 +132,10 @@
          bufferRequest[rank]=addr;
          return true;
-      }
+       }
       else
         return false;
     }
   }
+
 
   void CContextServer::checkPendingRequest(void)
@@ -174,4 +179,5 @@
     map<size_t,CEventServer*>::iterator it;
 
+    CTimer::get("Process request").resume();
     while(count>0)
     {
@@ -187,5 +193,5 @@
       count=buffer.remain();
     }
-
+    CTimer::get("Process request").suspend();
   }
 
@@ -233,5 +239,4 @@
   }
 
-
   void CContextServer::dispatchEvent(CEventServer& event)
   {
@@ -241,21 +246,23 @@
     int rank;
     list<CEventServer::SSubEvent>::iterator it;
-    CContext::setCurrent(context->getId());
+    StdString ctxId = context->getId();
+    CContext::setCurrent(ctxId);
+    StdSize totalBuf = 0;
 
     if (event.classId==CContext::GetType() && event.type==CContext::EVENT_ID_CONTEXT_FINALIZE)
     {
       finished=true;
-      info(20)<<"Server Side context <"<<context->getId()<<"> finalized"<<endl;
+      info(20)<<" CContextServer: Receive context <"<<context->getId()<<"> finalize."<<endl;
+      context->finalize();
       std::map<int, StdSize>::const_iterator itbMap = mapBufferSize_.begin(),
-                                             iteMap = mapBufferSize_.end(), itMap;
-      StdSize totalBuf = 0;
+                           iteMap = mapBufferSize_.end(), itMap;
       for (itMap = itbMap; itMap != iteMap; ++itMap)
       {
-        report(10)<< " Memory report : Context <"<<context->getId()<<"> : server side : memory used for buffer of each connection to client" << endl
-                  << "  +) With client of rank " << itMap->first << " : " << itMap->second << " bytes " << endl;
+        rank = itMap->first;
+        report(10)<< " Memory report : Context <"<<ctxId<<"> : server side : memory used for buffer of each connection to client" << endl
+            << "  +) With client of rank " << rank << " : " << itMap->second << " bytes " << endl;
         totalBuf += itMap->second;
       }
-      context->finalize();
-      report(0)<< " Memory report : Context <"<<context->getId()<<"> : server side : total memory used for buffer "<<totalBuf<<" bytes"<<endl;
+      report(0)<< " Memory report : Context <"<<ctxId<<"> : server side : total memory used for buffer "<<totalBuf<<" bytes"<<endl;
     }
     else if (event.classId==CContext::GetType()) CContext::dispatchEvent(event);
Index: /XIOS/trunk/src/cxios.cpp
===================================================================
--- /XIOS/trunk/src/cxios.cpp	(revision 1536)
+++ /XIOS/trunk/src/cxios.cpp	(revision 1537)
@@ -18,4 +18,6 @@
   string CXios::clientFile="./xios_client";
   string CXios::serverFile="./xios_server";
+  string CXios::serverPrmFile="./xios_server1";
+  string CXios::serverSndFile="./xios_server2";
 
   bool CXios::isClient ;
@@ -24,12 +26,17 @@
   bool CXios::usingOasis ;
   bool CXios::usingServer = false;
+  bool CXios::usingServer2 = false;
+  int CXios::ratioServer2 = 50;
+  int CXios::nbPoolsServer2 = 1;
   double CXios::bufferSizeFactor = 1.0;
   const double CXios::defaultBufferSizeFactor = 1.0;
   StdSize CXios::minBufferSize = 1024 * sizeof(double);
+  StdSize CXios::maxBufferSize = std::numeric_limits<int>::max() ;
   bool CXios::printLogs2Files;
   bool CXios::isOptPerformance = true;
   CRegistry* CXios::globalRegistry = 0;
-  double CXios::recvFieldTimeout = 10.0;
-
+  double CXios::recvFieldTimeout = 300.0;
+  bool CXios::checkEventSync=false ;
+ 
   //! Parse configuration file and create some objects from it
   void CXios::initialize()
@@ -48,4 +55,7 @@
     usingOasis=getin<bool>("using_oasis",false) ;
     usingServer=getin<bool>("using_server",false) ;
+    usingServer2=getin<bool>("using_server2",false) ;
+    ratioServer2=getin<int>("ratio_server2",50);
+    nbPoolsServer2=getin<int>("number_pools_server2",0);
     info.setLevel(getin<int>("info_level",0)) ;
     report.setLevel(getin<int>("info_level",50));
@@ -64,7 +74,10 @@
     bufferSizeFactor = getin<double>("buffer_size_factor", defaultBufferSizeFactor);
     minBufferSize = getin<int>("min_buffer_size", 1024 * sizeof(double));
-    recvFieldTimeout = getin<double>("recv_field_timeout", 10.0);
+    maxBufferSize = getin<int>("max_buffer_size", std::numeric_limits<int>::max());
+    recvFieldTimeout = getin<double>("recv_field_timeout", recvFieldTimeout);
     if (recvFieldTimeout < 0.0)
       ERROR("CXios::parseXiosConfig()", "recv_field_timeout cannot be negative.");
+
+    checkEventSync = getin<bool>("check_event_sync", checkEventSync);
 
     globalComm=MPI_COMM_WORLD ;
@@ -148,10 +161,23 @@
     // Initialize all aspects MPI
     CServer::initialize();
-    if (CServer::getRank()==0) globalRegistry = new CRegistry(CServer::intraComm) ;
+    if (CServer::getRank()==0 && CServer::serverLevel != 1) globalRegistry = new CRegistry(CServer::intraComm) ;
     
     if (printLogs2Files)
     {
-      CServer::openInfoStream(serverFile);
-      CServer::openErrorStream(serverFile);
+      if (CServer::serverLevel == 0)
+      {
+        CServer::openInfoStream(serverFile);
+        CServer::openErrorStream(serverFile);
+      }
+      else if (CServer::serverLevel == 1)
+      {
+        CServer::openInfoStream(serverPrmFile);
+        CServer::openErrorStream(serverPrmFile);
+      }
+      else
+      {
+        CServer::openInfoStream(serverSndFile);
+        CServer::openErrorStream(serverSndFile);
+      }
     }
     else
@@ -165,10 +191,72 @@
 
     // Finalize
-     if (CServer::getRank()==0)
-     {
-       info(80)<<"Write data base Registry"<<endl<<globalRegistry->toString()<<endl ;
-       globalRegistry->toFile("xios_registry.bin") ;
-       delete globalRegistry ;
-     }
+    if (CServer::serverLevel == 0)
+    {
+      if (CServer::getRank()==0)
+      {
+        info(80)<<"Write data base Registry"<<endl<<globalRegistry->toString()<<endl ;
+        globalRegistry->toFile("xios_registry.bin") ;
+        delete globalRegistry ;
+      }
+    }
+    else
+    {
+      // If using two server levels:
+      // (1) merge registries on each pool
+      // (2) send merged registries to the first pool
+      // (3) merge received registries on the first pool
+      if (CServer::serverLevel == 2)
+      {
+        vector<int>& secondaryServerGlobalRanks = CServer::getSecondaryServerGlobalRanks();
+        int firstPoolGlobalRank = secondaryServerGlobalRanks[0];
+        int rankGlobal;
+        MPI_Comm_rank(globalComm, &rankGlobal);
+
+        // Merge registries defined on each pools
+        CRegistry globalRegistrySndServers (CServer::intraComm);
+
+        // All pools (except the first): send globalRegistry to the first pool
+        for (int i=1; i<secondaryServerGlobalRanks.size(); i++)
+        {
+          if (rankGlobal == secondaryServerGlobalRanks[i])
+          {
+            globalRegistrySndServers.mergeRegistry(*globalRegistry) ;
+            int registrySize = globalRegistrySndServers.size();
+            MPI_Send(&registrySize,1,MPI_LONG,firstPoolGlobalRank,15,CXios::globalComm) ;
+            CBufferOut buffer(registrySize) ;
+            globalRegistrySndServers.toBuffer(buffer) ;
+            MPI_Send(buffer.start(),registrySize,MPI_CHAR,firstPoolGlobalRank,15,CXios::globalComm) ;
+          }
+        }
+
+        // First pool: receive globalRegistry of all secondary server pools, merge and write the resultant registry
+        if (rankGlobal == firstPoolGlobalRank)
+        {
+          MPI_Status status;
+          char* recvBuff;
+
+          globalRegistrySndServers.mergeRegistry(*globalRegistry) ;
+
+          for (int i=1; i< secondaryServerGlobalRanks.size(); i++)
+          {
+            int rank = secondaryServerGlobalRanks[i];
+            int registrySize = 0;
+            MPI_Recv(&registrySize, 1, MPI_LONG, rank, 15, CXios::globalComm, &status);
+            recvBuff = new char[registrySize];
+            MPI_Recv(recvBuff, registrySize, MPI_CHAR, rank, 15, CXios::globalComm, &status);
+            CBufferIn buffer(recvBuff, registrySize) ;
+            CRegistry recvRegistry;
+            recvRegistry.fromBuffer(buffer) ;
+            globalRegistrySndServers.mergeRegistry(recvRegistry) ;
+            delete[] recvBuff;
+          }
+
+          info(80)<<"Write data base Registry"<<endl<<globalRegistrySndServers.toString()<<endl ;
+          globalRegistrySndServers.toFile("xios_registry.bin") ;
+
+        }
+      }
+      delete globalRegistry;
+    }
     CServer::finalize();
 
Index: /XIOS/trunk/src/cxios.hpp
===================================================================
--- /XIOS/trunk/src/cxios.hpp	(revision 1536)
+++ /XIOS/trunk/src/cxios.hpp	(revision 1537)
@@ -29,6 +29,8 @@
      static string rootFile ; //!< Configuration filename
      static string xiosCodeId ; //!< Identity for XIOS
-     static string clientFile; //!< Filename template for client
-     static string serverFile; //!< Filename template for server
+     static string clientFile;        //!< Filename template for client
+     static string serverFile;        //!< Filename template for server
+     static string serverPrmFile;  //!< Filename template for primary server in case of two server levels
+     static string serverSndFile;  //!< Filename template for secondary server in case of two server levels
 
      static bool isClient ; //!< Check if xios is client
@@ -38,12 +40,17 @@
 
      static bool printLogs2Files; //!< Printing out logs into files
-     static bool usingOasis ; //!< Using Oasis
-     static bool usingServer ; //!< Using server (server mode)
+     static bool usingOasis ;     //!< Using Oasis
+     static bool usingServer ;    //!< Using server (server mode)
+     static bool usingServer2 ;   //!< Using secondary server (server mode). IMPORTANT: Use this variable ONLY in CServer::initialize().
+     static int ratioServer2 ;    //!< Percentage of server processors dedicated to secondary server
+     static int nbPoolsServer2 ;  //!< Number of pools created on the secondary server
      static double bufferSizeFactor; //!< Factor used to tune the buffer size
      static const double defaultBufferSizeFactor; //!< Default factor value
      static StdSize minBufferSize; //!< Minimum buffer size
+     static StdSize maxBufferSize; //!< Maximum buffer size
      static bool isOptPerformance; //!< Check if buffer size is for performance (as large as possible)
      static CRegistry* globalRegistry ; //!< global registry which is wrote by the root process of the servers
      static double recvFieldTimeout; //!< Time to wait for data before issuing an error when receiving a field
+     static bool checkEventSync; //!< For debuuging, check if event are coherent and synchrone on client side
 
     public:
